unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms,
  Controls, Graphics, Dialogs, ExtCtrls;

type

  { TMyThread }

  TMyThread = Class(TThread)

  public

    constructor Create(Nr: Integer);

    procedure ShowData;

  protected

    procedure Execute; override;

  private

    FNr: Integer;

    FData: Array[0..99] of Double;

  end;

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart1LineSeries2: TLineSeries;
    Chart1LineSeries3: TLineSeries;
    Chart1LineSeries4: TLineSeries;
    Chart1LineSeries5: TLineSeries;
    Chart1LineSeries6: TLineSeries;
    Chart1LineSeries7: TLineSeries;
    CheckGroup1: TCheckGroup;
    procedure CheckGroup1ItemClick(Sender: TObject;
      Index: integer);
    procedure FormDestroy(Sender: TObject);
  private
    Threads: Array[1..7] of TMyThread;
  end;

var

  Form1: TForm1;

  Daten: Array[1..7, 0..99] of Double;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.CheckGroup1ItemClick(Sender: TObject; Index: integer);
begin

  Inc(Index);

  if Assigned(Threads[Index]) then begin

    Threads[Index].Terminate;

    Threads[Index] := Nil;

  end else Threads[Index] := TMyThread.Create(Index);

end;

procedure TForm1.FormDestroy(Sender: TObject);
var

  i: Integer;

begin

  for i := 7 downto 1 do if Assigned(Threads[i]) then Threads[i].Terminate;

  Sleep(100);

end;

{ TMyThread }

constructor TMyThread.Create(Nr: Integer);
begin

  FNr := Nr;

  FreeOnTerminate := True;

  inherited Create(False);

end;

procedure TMyThread.ShowData;
var

 LS: TLineSeries;

begin

 Daten[FNr] := FData;

 case FNr of

  1: LS := Form1.Chart1LineSeries1;
  2: LS := Form1.Chart1LineSeries2;
  3: LS := Form1.Chart1LineSeries3;
  4: LS := Form1.Chart1LineSeries4;
  5: LS := Form1.Chart1LineSeries5;
  6: LS := Form1.Chart1LineSeries6;
  7: LS := Form1.Chart1LineSeries7;

 end;

 LS.BeginUpdate;

 LS.Clear;

 LS.AddArray(Daten[FNr]);

 LS.EndUpdate;

 Form1.Repaint;

 Application.ProcessMessages;

end;

procedure TMyThread.Execute;
var

  i , Cnt: Integer;

begin

  while not terminated do begin

    for i := 0 to 99 do FData[i] := ((7.5 - FNr)/3.5 - 1)/1.2 + Sin(i/5 + Cnt*FNr/50)/5;

    Synchronize(@ShowData);

    Inc(Cnt);

    Sleep(10);

  end;

end;

end.

